![Trident](https://github.com/kakaobrain/trident/assets/7459074/aee6bb37-45a4-4b8e-bf14-0ea63dc574a0)

![Welcome](https://capsule-render.vercel.app/api?type=rect&color=001eff&text=👋%20Hello%20and%20Welcome&fontColor=ffffff)

## 🔱 Overview

Trident is a performance library for machine learning applications intended for acceleration of training and inference.
Trident includes highly optimized kernels, functions and modules for machine learning. Trident is implemented based on
[OpenAI Triton](https://github.com/openai/triton). Check [Wiki](https://github.com/kakaobrain/trident/wiki) for more
detail.

## 💻 Requirements

- Platform: Linux
- Hardware: NVIDIA

## 📦 Installation

```bash
bash install_package.sh
```

You can also install Trident using pip.

```bash
pip install git+https://github.com/kakaobrain/trident.git
```

You can add Trident in `requirements.txt`.

```text
trident@git+https://github.com/kakaobrain/trident.git@main
```

## 📖 How to use

![how-to-use](https://github.com/kakaobrain/trident/assets/7459074/2876a2ca-d7cc-4d60-be81-b8d58cbb9f17)

## 🧑‍💻 Contribution

You must set up `pre-commit` to maintain the consistent coding style.

```bash
pre-commit install
```
